#include <iostream>
#include <string>
#include <cmath>
using namespace std;

int main()
{
	cout << "Taille d'une variable de type double : " << sizeof(double)<< endl << endl;
	
	double* ptr1(new double(0.));
	cout << "Adresse du premier octet réservé :     " << ptr1  << endl << endl;

	double* ptr2(new double(0.));
	cout << "Adresse du premier octet réservé :     " << ptr2  << endl << endl;

	// le système alloue des blocs consécutifs, la taille d'un bloc s'obtient
	// en faisant la différence de 2 allocations successives
	
	cout << "ecart entre les 2 adresses = taille allouée dynamiquement " << endl<<endl;
	cout << "       " << (ptr2 -ptr1) << "*(sizeof(double))= " 
	                                  << (ptr2 -ptr1)*sizeof(double)     
	                                  << " octets"                        <<endl<<endl;
	
	// Comment delete connait-il la taille à libérer puisqu'on ne la donne pas en paramètre ?
	
	// Hypothèse fréquente (non-standardisé): taille est stockée juste avant le bloc
	// réservé (sur 64 bits). Ainsi delete peut la lire et libérer l'espace correct.
	
	cout << "Valeur double mémorisée                :" << *ptr2 << endl;
	cout << "Valeur stockée dans le mot qui précède :" 
	     << *((unsigned long long*)(ptr2-1)) << endl;

	// confirmons avec la valeur stockée avant ptr1.
	
	cout << "Valeur double mémorisée                :" << *ptr1 << endl;
	cout << "Valeur stockée dans le mot qui précède :" 
	     << *((unsigned long long*)(ptr1-1)) << endl;

	//================================================================================
	cout << endl << endl ;
	
	double* ptr3(new double[32]);
	cout << "Adresse du premier octet réservé :     " << ptr3  << endl << endl;

	double* ptr4(new double[32]);
	cout << "Adresse du premier octet réservé :     " << ptr4  << endl << endl;

	// le système alloue des blocs consécutifs, la taille d'un bloc s'obtient
	// en faisant la différence de 2 allocations successives
	
	cout << "ecart entre les 2 adresses = taille allouée dynamiquement " << endl<<endl;
	cout << "       " << (ptr4 -ptr3) << "*(sizeof(double))= " 
	                                  << (ptr4 -ptr3)*sizeof(double)     
	                                  << " octets"                        <<endl<<endl;
		
	cout << "Valeur stockée dans le mot qui précède :" 
	     << *((unsigned long long*)(ptr4-1)) << endl;

	// confirmons avec la valeur stockée avant ptr1.
	
	cout << "Valeur stockée dans le mot qui précède :" 
	     << *((unsigned long long*)(ptr3-1)) << endl;


	return 0;
}
